/*
 
 Copyright 1996 by J.D. Koftinoff Software Ltd, 
 under the KPL (Koftinoff Public License)
 
 THE NO-NONSENSE KOFTINOFF PUBLIC LICENSE (KPL)

 
 This software is provided free of charge.  You use this software only under 
 the following conditions:
 
    * You agree that you use this software at your own risk
    * You agree that the copyright of this software is held 
      by J.D. Koftinoff Software, Ltd.
 
 If you agree to these conditions, you may modify and use the software in 
 commercial as well as free projects.  However, If you use this software in a 
 commercial project, you MUST send a neat postcard to me at:
 
    Jeff Koftinoff
    J.D. Koftinoff Software, Ltd.
    #5 - 1131 Burnaby St.
    Vancouver, B.C.
    Canada
    V6E-1P3
 
    email: jeffk@jdkoftinoff.com
 
 Have Fun!
 
 P.S. Send me a postcard anyways please! I'll send one back!
 */

#ifndef __JKCTHREAD_H
#define __JKCTHREAD_H

#include <signal.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include <linux/unistd.h>
#include <asm/atomic.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>    

#ifdef __cplusplus
extern "C"
{
#endif


#define JKMAX_THREADS (128)
#define JKMAX_SEMS (256)
#define JKMAX_MSGQS  (JKMAX_THREADS)
#define JKMIN_STACK (16384)


typedef struct _jkthreadinfo
{   
	pid_t   thr_id;
	int     thr_errno;
	int     thr_h_errno;
	void    (*start_func)(void *);
	void    (*term_func)(void *);
	void    *start_param;
	int     thr_local[32];
} jkthreadinfo;

typedef struct _jksem
{
	int         usage;
	pid_t       owner;
    int         sem_id;
} jksem;


extern jkthreadinfo _jkthreadinfos[JKMAX_THREADS];
extern jkthreadinfo _jkdummythread;
extern jksem _jksems[JKMAX_SEMS];
extern jksem _jksyssem;
extern jksem _jklibc_sem;
	

void jkthread_init(void);
int jkthread_create(void (*fn)(void *), void *data, int stacksz, void (*term_fn)(void *));
void jkthread_kill( pid_t id );
int *jkthread_getlocal(void);	

jksem *jksem_create( void );
jksem *jksem_create1( int initial_count );	
void jksem_init( jksem *s );
void jksem_init1( jksem *s, int initial_count );	
void jksem_kill( jksem *s );
int jksem_get( jksem *s );
int jksem_tryget( jksem *s );
void jksem_release( jksem *s );
int jkrsem_get( jksem *s );
int jkrsem_tryget( jksem *s );
void jkrsem_release( jksem *s );
	
	
	
void * malloc( size_t );
void * calloc( size_t, size_t );
void * realloc( void *, size_t );
void free(void * );
unsigned int sleep( unsigned int );

	

	
#ifdef __cplusplus
}
#endif
	
#endif
